// noise.cpp
#include <cmath>
#include <cstdlib>

#include "noise.h"

double Noise::getgauss(double sig)
{
  double x1, x2, w, y;
  
  if(!have_gauss){
    do {
      x1 = 2.0 * get() - 1.0;
      x2 = 2.0 * get() - 1.0;
      w = x1 * x1 + x2 * x2;
    } while ( w >= 1.0 );
    
    w = sqrt( (-2.0 * log( w ) ) / w );
    y = x1 * w;
    rand_prv = x2 * w;
    
    have_gauss = true;
    //return sqrt(sig) * y;
    return sig * y;
  }else{
    have_gauss = false;
    //return sqrt(sig) * rand_prv;
    return sig * rand_prv;
  }
}

