// proc.cpp
#include <windows.h>
#include <cstdlib>
#define _USE_MATH_DEFINES
#include <cmath>
#include <new>
#include <mmintrin.h>

#include "filter.h"
#include "proc.h"
#include "noise.h"

//덷e[u
void init_sum(PIXEL_YC *tbl, int h, int w)
{
  Noise n;
  
  for(int i=0; i<h; ++i){
    for(int j=0; j<w; ++j){
      tbl->y  = (short)(n.get(4095.0) + 0.5);
      tbl->cb = (short)(n.get(127.0) + 0.5);
      tbl->cr = (short)(n.get(127.0) + 0.5);
      ++tbl;
    }
  }
}

//ACg킹pp
union u64 {
  short i16[4];
  __m64 m64;
};

//PIXEL_YC to YUY2
// Yout = ((Yin*219 + 383)>>12) + 16;
// Cout = (((Cin + 2048)*7 + 66)>>7) + 16;
const u64 a0 = {   219,     7,     7,   219 };
const u64 b0 = { 0xFFF,  0x7F,  0x7F, 0xFFF };
const u64 c0 = {   299,  9362,  9362,   299 };
//const u64 d0 = {   383,    66,    66,   383 };
const u64 a1 = {     7,     7,   219,     7 };
const u64 b1 = {  0x7F,  0x7F, 0xFFF,  0x7F };
const u64 c1 = {  9362,  9362,   299,  9362 };
//const u64 d1 = {    66,    66,   383,    66 };
const u64 a2 = {     7,   219,     7,     7 };
const u64 b2 = {  0x7F, 0xFFF,  0x7F,  0x7F };
const u64 c2 = {  9362,   299,  9362,  9362 };
//const u64 d2 = {    66,   383,    66,    66 };

//ԎɌ덷tB[hobN
void feedback_err(PIXEL_YC *img, PIXEL_YC *tbl, int h, int w, int sw)
{
  __m64 i0,i1,i2;
  __m64 *im;
  __m64 *tb = (__m64*)tbl;

  w /= 4; //4pixel𓯎ɏ
  
  for(int i=0; i<h; ++i){
    im = (__m64*)img;
    for(int j=0; j<w; ++j){
      //i0 reg( Y1,Cr0,Cb0, Y0) mem( Y0,Cb0,Cr0, Y1)
      //i1 reg(Cb2, Y2,Cr1,Cb1) mem(Cb1,Cr1, Y2,Cb2)
      //i2 reg(Cr3,Cb3, Y3,Cr2) mem(Cr2, Y3,Cb3,Cr3)
      i0 = _mm_mulhi_pi16(*tb, c0.m64);
      i1 = _mm_mulhi_pi16(*(tb+1), c1.m64);
      i2 = _mm_mulhi_pi16(*(tb+2), c2.m64);

      i0 = _mm_adds_pi16(i0, *im);
      i1 = _mm_adds_pi16(i1, *(im+1));
      i2 = _mm_adds_pi16(i2, *(im+2));

      *im     = i0;
      *(im+1) = i1;
      *(im+2) = i2;

      i0 = _mm_mullo_pi16(i0, a0.m64);
      i1 = _mm_mullo_pi16(i1, a1.m64);
      i2 = _mm_mullo_pi16(i2, a2.m64);

      *tb     = _mm_and_si64(i0, b0.m64);
      *(tb+1) = _mm_and_si64(i1, b1.m64);
      *(tb+2) = _mm_and_si64(i2, b2.m64);
      
      im += 3;
      tb += 3;
    }
    img += sw;
  }
  
  _mm_empty();
}

//mCYt
void add_noise(PIXEL_YC *img, const PIXEL_YC *tbl, int h, int ht, int w, int sw)
{
  w /= 4; //4pixel𓯎ɏ

  __m64 *im;
  const __m64 *tb = (__m64*)tbl;
  const int offs = (int)((w * (ht - h) * (double)rand())/RAND_MAX);
  tb += 3*offs;
  //mCYe[ũItZbg(ht-h)C܂ŋe
  
  for(int i=0; i<h; ++i){
    im = (__m64*)img;
    for(int j=0; j<w; ++j){
      *im     = _mm_adds_pi16(*im, *tb);
      *(im+1) = _mm_adds_pi16(*(im+1), *(tb+1));
      *(im+2) = _mm_adds_pi16(*(im+2), *(tb+2));

      im += 3;
      tb += 3;
    }
    img += sw;
  }
  
  _mm_empty();
}

//lmCỸe[u쐬
void init_noise(PIXEL_YC *tbl, int h, int w, int wy, int wc, bool init)
{
  static int weight_y = -1;
  static int weight_c = -1;

  //ύXȂ
  if(wy == weight_y && wc == weight_c && !init){
    return;
  }

  Noise n;
  
  for(int i=0; i<h; ++i){
    for(int j=0; j<w; ++j){
      tbl->y  = (short)(wy * (n.get(4.0) - 2.0));
      tbl->cb = (short)(wc * (n.get(4.0) - 2.0));
      tbl->cr = (short)(wc * (n.get(4.0) - 2.0));
      ++tbl;
    }
  }

  weight_y = wy;
  weight_c = wc;
}

//lmCỸe[u쐬
//LPFɂш搧
void init_noise_l1d(PIXEL_YC *tbl, int h, int w, int wy, int wc, bool init)
{
  static int weight_y = -1;
  static int weight_c = -1;

  //ύXȂ
  if(wy == weight_y && wc == weight_c && !init){
    return;
  }

  Noise n;
  double dy,dcb,dcr;
  double py,pcb,pcr; //ÕTv
  const double scale = M_SQRT2 * 2.0; //p[𓯂ɂ

  //f[^
  py  = n.get();
  pcb = n.get();
  pcr = n.get();

  //C[v
  for(int i=0; i<h; ++i){
    for(int j=0; j<w; ++j){
      dy  = n.get();
      dcb = n.get();
      dcr = n.get();
      py  += dy;
      pcb += dcb;
      pcr += dcr;
      
      tbl->y  = (short)(wy * (scale * py  - scale));
      tbl->cb = (short)(wc * (scale * pcb - scale));
      tbl->cr = (short)(wc * (scale * pcr - scale));
      
      py = dy;
      pcb = dcb;
      pcr = dcr;
      
      ++tbl;
    }
  }

  weight_y = wy;
  weight_c = wc;
}

//lmCỸe[u쐬
//2LPFɂш搧
void init_noise_l2d(PIXEL_YC *tbl, int h, int w, int wy, int wc, bool init)
{
  static int weight_y = -1;
  static int weight_c = -1;

  //ύXȂ
  if(wy == weight_y && wc == weight_c && !init){
    return;
  }

  Noise n;
  const double scale = 2.0; //p[𓯂ɂ
  double dy,dcb,dcr;
  double py,pcb,pcr; //ÕTv
  double *ln = new(std::nothrow) double[3*w];
  if(NULL == ln) return;

  //ꎞ̈̃f[^
  py  = n.get();
  pcb = n.get();
  pcr = n.get();
  for(int k=0; k<w; ++k){
    dy  = n.get();
    dcb = n.get();
    dcr = n.get();
    ln[3*k]     = dy + py;
    ln[3*k + 1] = dcb + pcb;
    ln[3*k + 2] = dcr + pcr;
    py = dy;
    pcb = dcb;
    pcr = dcr;
  }

  //C[v
  for(int i=0; i<h; ++i){
    for(int j=0; j<w; ++j){
      dy  = n.get();
      dcb = n.get();
      dcr = n.get();
      py  += dy;
      pcb += dcb;
      pcr += dcr;
      
      tbl->y  = (short)(wy * scale * (py  - 2.0 + ln[3*j]));
      tbl->cb = (short)(wc * scale * (pcb - 2.0 + ln[3*j + 1]));
      tbl->cr = (short)(wc * scale * (pcr - 2.0 + ln[3*j + 2]));

      ln[3*j]     = py;
      ln[3*j + 1] = pcb;
      ln[3*j + 2] = pcr;
      py = dy;
      pcb = dcb;
      pcr = dcr;
      
      ++tbl;
    }
  }

  delete[] ln;
  weight_y = wy;
  weight_c = wc;
}

//lmCỸe[u쐬
//2HPFɂш搧
void init_noise_h2d(PIXEL_YC *tbl, int h, int w, int wy, int wc, bool init)
{
  static int weight_y = -1;
  static int weight_c = -1;

  //ύXȂ
  if(wy == weight_y && wc == weight_c && !init){
    return;
  }

  Noise n;
  const double scale = 2.0; //p[𓯂ɂ
  double dy,dcb,dcr;
  double py,pcb,pcr; //ÕTv
  double *ln = new(std::nothrow) double[3*w];
  if(NULL == ln) return;

  //ꎞ̈̃f[^
  py  = n.get();
  pcb = n.get();
  pcr = n.get();
  for(int k=0; k<w; ++k){
    dy  = n.get();
    dcb = n.get();
    dcr = n.get();
    ln[3*k]     = py  - dy;
    ln[3*k + 1] = pcb - dcb;
    ln[3*k + 2] = pcr - dcr;
    py = dy;
    pcb = dcb;
    pcr = dcr;
  }

  //C[v
  for(int i=0; i<h; ++i){
    for(int j=0; j<w; ++j){
      dy  = n.get();
      dcb = n.get();
      dcr = n.get();
      py  -= dy;
      pcb -= dcb;
      pcr -= dcr;
      
      tbl->y  = (short)(wy * scale * (ln[3*j] - py));
      tbl->cb = (short)(wc * scale * (ln[3*j + 1] - pcb));
      tbl->cr = (short)(wc * scale * (ln[3*j + 2] - pcr));

      ln[3*j]     = py;
      ln[3*j + 1] = pcb;
      ln[3*j + 2] = pcr;
      py = dy;
      pcb = dcb;
      pcr = dcr;
      
      ++tbl;
    }
  }

  delete[] ln;
  weight_y = wy;
  weight_c = wc;
}

//KEXmCỸe[u쐬
void init_gauss(PIXEL_YC *tbl, int h, int w, int wy, int wc, bool init)
{
  static int sig_y = -1;
  static int sig_c = -1;

  //ύXȂ
  if(wy == sig_y && wc == sig_c && !init){
    return;
  }

  Noise n;
  
  for(int i=0; i<h; ++i){
    for(int j=0; j<w; ++j){
      tbl->y  = (short)n.getgauss(wy);
      tbl->cb = (short)n.getgauss(wc);
      tbl->cr = (short)n.getgauss(wc);
      ++tbl;
    }
  }

  sig_y = wy;
  sig_c = wc;
}

//KEXmCỸe[u쐬
//LPFɂш搧
void init_gauss_l1d(PIXEL_YC *tbl, int h, int w, int wy, int wc, bool init)
{
  static int sig_y = -1;
  static int sig_c = -1;

  //ύXȂ
  if(wy == sig_y && wc == sig_c && !init){
    return;
  }

  Noise n;
  double dy,dcb,dcr;
  double py,pcb,pcr; //ÕTv
  const double scale = 0.5 * M_SQRT2; //p[𓯂ɂ

  //f[^
  py  = n.getgauss(wy);
  pcb = n.getgauss(wc);
  pcr = n.getgauss(wc);

  //C[v
  for(int i=0; i<h; ++i){
    for(int j=0; j<w; ++j){
      dy  = n.getgauss(wy);
      dcb = n.getgauss(wc);
      dcr = n.getgauss(wc);
      py  += dy;
      pcb += dcb;
      pcr += dcr;
      
      tbl->y  = (short)(scale * py);
      tbl->cb = (short)(scale * pcb);
      tbl->cr = (short)(scale * pcr);

      py = dy;
      pcb = dcb;
      pcr = dcr;
      
      ++tbl;
    }
  }

  sig_y = wy;
  sig_c = wc;
}

//KEXmCỸe[u쐬
//2LPFɂш搧
void init_gauss_l2d(PIXEL_YC *tbl, int h, int w, int wy, int wc, bool init)
{
  static int sig_y = -1;
  static int sig_c = -1;

  //ύXȂ
  if(wy == sig_y && wc == sig_c && !init){
    return;
  }

  Noise n;
  const double scale = 0.5; //p[𓯂ɂ
  double dy,dcb,dcr;
  double py,pcb,pcr; //ÕTv
  double *ln = new(std::nothrow) double[3*w];
  if(NULL == ln) return;

  //ꎞ̈̃f[^
  py  = n.getgauss(wy);
  pcb = n.getgauss(wc);
  pcr = n.getgauss(wc);
  for(int k=0; k<w; ++k){
    dy  = n.getgauss(wy);
    dcb = n.getgauss(wc);
    dcr = n.getgauss(wc);
    ln[3*k]     = dy + py;
    ln[3*k + 1] = dcb + pcb;
    ln[3*k + 2] = dcr + pcr;
    py = dy;
    pcb = dcb;
    pcr = dcr;
  }

  //C[v
  for(int i=0; i<h; ++i){
    for(int j=0; j<w; ++j){
      dy  = n.getgauss(wy);
      dcb = n.getgauss(wc);
      dcr = n.getgauss(wc);
      py  += dy;
      pcb += dcb;
      pcr += dcr;
      
      tbl->y  = (short)(scale*(py  + ln[3*j]));
      tbl->cb = (short)(scale*(pcb + ln[3*j + 1]));
      tbl->cr = (short)(scale*(pcr + ln[3*j + 2]));

      ln[3*j]     = py;
      ln[3*j + 1] = pcb;
      ln[3*j + 2] = pcr;
      py = dy;
      pcb = dcb;
      pcr = dcr;
      
      ++tbl;
    }
  }

  delete[] ln;
  sig_y = wy;
  sig_c = wc;
}

//KEXmCỸe[u쐬
//2HPFɂш搧
void init_gauss_h2d(PIXEL_YC *tbl, int h, int w, int wy, int wc, bool init)
{
  static int sig_y = -1;
  static int sig_c = -1;

  //ύXȂ
  if(wy == sig_y && wc == sig_c && !init){
    return;
  }

  Noise n;
  const double scale = 0.5; //p[𓯂ɂ
  double dy,dcb,dcr;
  double py,pcb,pcr; //ÕTv
  double *ln = new(std::nothrow) double[3*w];
  if(NULL == ln) return;

  //ꎞ̈̃f[^
  py  = n.getgauss(wy);
  pcb = n.getgauss(wc);
  pcr = n.getgauss(wc);
  for(int k=0; k<w; ++k){
    dy  = n.getgauss(wy);
    dcb = n.getgauss(wc);
    dcr = n.getgauss(wc);
    ln[3*k]     = py  - dy;
    ln[3*k + 1] = pcb - dcb;
    ln[3*k + 2] = pcr - dcr;
    py = dy;
    pcb = dcb;
    pcr = dcr;
  }

  //C[v
  for(int i=0; i<h; ++i){
    for(int j=0; j<w; ++j){
      dy  = n.getgauss(wy);
      dcb = n.getgauss(wc);
      dcr = n.getgauss(wc);
      py  -= dy;
      pcb -= dcb;
      pcr -= dcr;
      
      tbl->y  = (short)(scale*(ln[3*j] - py));
      tbl->cb = (short)(scale*(ln[3*j + 1] - pcb));
      tbl->cr = (short)(scale*(ln[3*j + 2] - pcr));

      ln[3*j]     = py;
      ln[3*j + 1] = pcb;
      ln[3*j + 2] = pcr;
      py = dy;
      pcb = dcb;
      pcr = dcr;
      
      ++tbl;
    }
  }

  delete[] ln;
  sig_y = wy;
  sig_c = wc;
}

//mCY֐e[u
void (*ini_n[N_INIF])(PIXEL_YC *, int, int, int, int, bool) =
{ init_noise, init_noise,
  init_noise, init_noise_l1d, init_noise_l2d,
  init_gauss, init_gauss_l1d, init_gauss_l2d
  };


